=== modified file 'lib/lp/scripts/utilities/warninghandler.py'
--- lib/lp/scripts/utilities/warninghandler.py	2010-08-05 10:15:24 +0000
+++ lib/lp/scripts/utilities/warninghandler.py	2010-08-05 15:17:14 +0000
@@ -17,9 +17,6 @@
         self.message = message
         self.info = info
 
-    def __hash__(self):
-        return hash(self.message)
-
     def __str__(self):
         info = str(self.info)
         if info:
@@ -150,7 +147,9 @@
 
 need_page_titles = []
 no_order_by = []
-other_warnings = set()
+
+# Maps (category, filename, lineno) to WarningReport
+other_warnings = {}
 
 old_show_warning = warnings.showwarning
 def launchpad_showwarning(message, category, filename, lineno, file=None,
@@ -180,7 +179,8 @@
                     WarningReport(warning_message, important_info)
                     )
                 return
-    other_warnings.add(WarningReport(warning_message, important_info))
+    other_warnings[(category, filename, lineno)] = WarningReport(
+        warning_message, important_info)
 
 def report_need_page_titles():
     global need_page_titles
@@ -205,7 +205,7 @@
     if other_warnings:
         print
         print "General warnings."
-        for warninginfo in other_warnings:
+        for warninginfo in other_warnings.itervalues():
             print
             print warninginfo
 

